# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define bname xsom
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           jvnet-xsom
Version:        20110809
Release:        2%{?dist}
Epoch:          0
Summary:        XML Schema Object Model
License:        CDDL
Group:          Development/Libraries/Java
URL:            https://xsom.dev.java.net/
Source0:        xsom-20110809.tgz
# svn export https://svn.java.net/svn/xsom~sources/tags/xsom-20110809/
# tar czf ../xsom-20110809.tgz xsom-20110809/
Source1:        jvnet-xsom-jpp-depmap.xml
Source2:        jvnet-xsom-settings.xml
Source3:        http://download.java.net/maven/1/com.sun.xsom/poms/xsom-20070515.pom
Provides:       sun-xsom = %{epoch}:%{version}-%{release}
Obsoletes:      sun-xsom < %{epoch}:%{version}-%{release}
Requires:       relaxngDatatype
Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-antrun-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  jvnet-parent
BuildRequires:  isorelax
BuildRequires:  javacc
BuildRequires:  msv-msv
BuildRequires:  msv-xsdlib
BuildRequires:  relaxngDatatype
BuildRequires:  relaxngcc
BuildArch:      noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
XML Schema Object Model (XSOM) is a Java library that 
allows applications to easily parse XML Schema documents 
and inspect information in them. It is expected to be useful
for applications that need to take XML Schema as an input. 
The library is a straight-forward implement of 
"schema components" as defined in the XML Schema spec part 1. 
Refer to this specification of how this object model works. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n xsom-20110809

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 target/xsom-20110809.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{bname}-%{version}.jar

%add_to_maven_depmap com.sun.xsom xsom %{version} JPP/%{name} %{bname}

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE2} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-%{bname}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc license.txt
%{_javadir}/%{name}/%{bname}-%{version}.jar
%{_javadir}/%{name}/%{bname}.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Mon Feb 04 2013 Ralph Apel <r.apel@r-apel.de> 0:20110809-2
- Prevent xzpayload problem

* Fri Jan 11 2013 Ralph Apel <r.apel@r-apel.de> 0:20110809-1
- 20110809 as jvnet-xsom

* Wed Sep 22 2010 Ralph Apel <r.apel@r-apel.de> 0:20070515-3
- build for JPackage 6
- omit retroweaving and -jdk14 subpackage

* Fri Oct 10 2008 David Walluck <dwalluck@redhat.com> 0:20070515-2
- build for JPackage 5

* Tue Nov 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:20070515-1jpp
- First release

